<template>
  <div class="h-100">
    <ob-table
      :items="dataSource"
      :columns="columns"
      :functional-panel="true"
      :show-add-button="true"
      is-fixed-header
      @select="onSelectionChanged"
      @add="addNewRequisite"
    />

    <ob-modal
      :title="titleModal"
      ref="DocModal"
    >
      <doc-modal
        :data-source="selectedData"
        :disabled="!isNew"
        :recognizer-list="recognizerList"
        @close="$refs.DocModal.close()"
      />
    </ob-modal>
  </div>
</template>

<script>
import DocModal         from './modal/index';
import ObModal          from 'common-components/src/obComponents/obModal';
import ObTable          from 'common-components/src/obComponents/obTable/index';
import TableLayoutMixin from '@/mixins/table-layout-mixin';
import { dictionary } from '@/translations/ru/dictionaries__sb_dictionaries__registration_docs';

const regDocTypesList = [
  {
    uuid: 'ba605481-vf57-4be4-b2cc-8224671320960',
    name: 'Паспорт',
    entity: 'Участник, Ресурс',
    recognizerUuid: ['123', '5467'],
    status: true,
    createdAt: '21.11.2018'
  },
  {
    uuid: 'ba605481-vf57-4be4-b2cc-8224671320961',
    name: 'Свидетельство о регистрации юр. лица',
    entity: 'Участник, Ресурс',
    recognizerUuid: ['123'],
    status: true,
    createdAt: '21.11.2018'
  },
  {
    uuid: 'ba605481-vf57-4be4-b2cc-8224671320962',
    name: 'Справка о задолженности перед УФМС',
    entity: 'Участник',
    recognizerUuid: ['5467'],
    status: false,
    createdAt: '21.11.2018'
  },
  {
    uuid: 'ba605481-vf57-4be4-b2cc-8224671320963',
    name: 'Водительское удостоверение',
    entity: 'Участник',
    recognizerUuid: ['5467'],
    status: true,
    createdAt: '21.11.2018'
  },
  {
    uuid: 'ba605481-vf57-4be4-b2cc-8224671320964',
    name: 'Свидетельство о регистрации ТС',
    entity: 'Ресурс',
    recognizerUuid: ['123'],
    status: true,
    createdAt: '21.11.2018'
  }
];

const recognizerList = [
  {
    uuid: '123',
    title: 'SumSub'
  },
  {
    uuid: '5467',
    title: 'Directum'
  }
];

export default {
  name: 'DocsIndex',
  mixins: [TableLayoutMixin],
  components: { ObTable, DocModal, ObModal },
  computed: {
    isNew() {
      return (
        Object.entries(this.selectedData).length === 0 &&
        this.selectedData.constructor === Object
      );
    },
    titleModal() {
      return this.isNew
        ? 'Добавление регистрационного документа'
        : 'Регистрационный документ';
    },
    columns() {
      let _self = this;
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name'
        },
        {
          title: this.dictionaryRu.columns.entity,
          key: 'entity'
        },
        {
          title: this.dictionaryRu.columns.service,
          key: 'recognizerUuid',
          html: data => {
            return data.recognizerUuid.reduce((prev, current) => {
              let res = '';
              res += prev;
              let _current = _self.recognizerList.find(rec => {
                return rec.uuid === current;
              });
              if (_current) {
                res += prev.length > 0 ? ', ' : '';
                res += _current.title;
              }
              return res;
            }, '');
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          key: 'status',
          html: data => (data.status ? 'Активна' : 'Неактивна')
        },
        {
          title: this.dictionaryRu.columns.createdAt,
          key: 'createdAt'
        }
      ];
    }
  },
  data() {
    return {
      selectedData: {},
      dataSource: regDocTypesList,
      recognizerList: recognizerList,
      dictionaryRu: dictionary
    };
  },
  methods: {
    onSelectionChanged(data) {
      this.selectedData = data;
      this.$refs.DocModal.open();
    },
    addNewRequisite() {
      this.onSelectionChanged({});
    }
  }
};
</script>